/** 
 * Perform function call in reference context. Should always return value that can be passed to {@link #refGet(Ref,Context)} or {@link #refSet(Ref,Object,Context)}arbitrary number of times. The args array reference should not be stored in any object that is can be GC-reachable after this method returns. If this is necessary, store args.clone(), not args array itself.
 */
public static Ref callRef(Callable function,Scriptable thisObj,Object[] args,Context cx){
  if (function instanceof RefCallable) {
    RefCallable rfunction=(RefCallable)function;
    Ref ref=rfunction.refCall(cx,thisObj,args);
    if (ref == null) {
      throw new IllegalStateException(rfunction.getClass().getName() + ".refCall() returned null");
    }
    return ref;
  }
  String msg=getMessage1("msg.no.ref.from.function",toString(function));
  throw constructError("ReferenceError",msg);
}
