/** 
 * Add a method and begin adding code. This method must be called before other methods for adding code, exception tables, etc. can be invoked.
 * @param methodName the name of the method
 * @param type a string representing the type
 * @param flags the attributes of the field, such as ACC_PUBLIC, etc.bitwise or'd together
 */
public void startMethod(String methodName,String type,short flags){
  short methodNameIndex=itsConstantPool.addUtf8(methodName);
  short typeIndex=itsConstantPool.addUtf8(type);
  itsCurrentMethod=new ClassFileMethod(methodNameIndex,typeIndex,flags);
  itsMethods.add(itsCurrentMethod);
}
