/** 
 * Catch clause of try/catch/finally
 * @param varName the name of the variable to bind to the exception
 * @param catchCond the condition under which to catch the exception.May be null if no condition is given.
 * @param stmts the statements in the catch clause
 * @param lineno the starting line number of the catch clause
 */
Node createCatch(String varName,Node catchCond,Node stmts,int lineno){
  if (catchCond == null) {
    catchCond=new Node(Token.EMPTY);
  }
  return new Node(Token.CATCH,createName(varName),catchCond,stmts,lineno);
}
