/** 
 * For .. In
 */
Node createForIn(int declType,Node loop,Node lhs,Node obj,Node body,boolean isForEach){
  int destructuring=-1;
  int destructuringLen=0;
  Node lvalue;
  int type=lhs.getType();
  if (type == Token.VAR || type == Token.LET) {
    Node lastChild=lhs.getLastChild();
    if (lhs.getFirstChild() != lastChild) {
      parser.reportError("msg.mult.index");
    }
    if (lastChild.getType() == Token.ARRAYLIT || lastChild.getType() == Token.OBJECTLIT) {
      type=destructuring=lastChild.getType();
      lvalue=lastChild;
      destructuringLen=lastChild.getIntProp(Node.DESTRUCTURING_ARRAY_LENGTH,0);
    }
 else     if (lastChild.getType() == Token.NAME) {
      lvalue=Node.newString(Token.NAME,lastChild.getString());
    }
 else {
      parser.reportError("msg.bad.for.in.lhs");
      return obj;
    }
  }
 else   if (type == Token.ARRAYLIT || type == Token.OBJECTLIT) {
    destructuring=type;
    lvalue=lhs;
    destructuringLen=lhs.getIntProp(Node.DESTRUCTURING_ARRAY_LENGTH,0);
  }
 else {
    lvalue=makeReference(lhs);
    if (lvalue == null) {
      parser.reportError("msg.bad.for.in.lhs");
      return obj;
    }
  }
  Node localBlock=new Node(Token.LOCAL_BLOCK);
  int initType=(isForEach) ? Token.ENUM_INIT_VALUES : (destructuring != -1) ? Token.ENUM_INIT_ARRAY : Token.ENUM_INIT_KEYS;
  Node init=new Node(initType,obj);
  init.putProp(Node.LOCAL_BLOCK_PROP,localBlock);
  Node cond=new Node(Token.ENUM_NEXT);
  cond.putProp(Node.LOCAL_BLOCK_PROP,localBlock);
  Node id=new Node(Token.ENUM_ID);
  id.putProp(Node.LOCAL_BLOCK_PROP,localBlock);
  Node newBody=new Node(Token.BLOCK);
  Node assign;
  if (destructuring != -1) {
    assign=createDestructuringAssignment(declType,lvalue,id);
    if (!isForEach && (destructuring == Token.OBJECTLIT || destructuringLen != 2)) {
      parser.reportError("msg.bad.for.in.destruct");
    }
  }
 else {
    assign=simpleAssignment(lvalue,id);
  }
  newBody.addChildToBack(new Node(Token.EXPR_VOID,assign));
  newBody.addChildToBack(body);
  loop=createWhile(loop,cond,newBody);
  loop.addChildToFront(init);
  if (type == Token.VAR || type == Token.LET)   loop.addChildToFront(lhs);
  localBlock.addChildToBack(loop);
  return localBlock;
}
