/** 
 * Decompile the body of a JavaScript Function. <p> Decompiles the body a previously compiled JavaScript Function object to canonical source, omitting the function header and trailing brace. Returns '[native code]' if no decompilation information is available.
 * @param fun the JavaScript function to decompile
 * @param indent the number of spaces to indent the result
 * @return a string representing the function body source.
 */
public final String decompileFunctionBody(Function fun,int indent){
  if (fun instanceof BaseFunction) {
    BaseFunction bf=(BaseFunction)fun;
    return bf.decompile(indent,Decompiler.ONLY_BODY_FLAG);
  }
  return "[native code]\n";
}
