/** 
 * Assign every symbol a unique integer index. Generate arrays of variable  names and constness that can be indexed by those indices.
 * @param flattenAllTables if true, flatten all symbol tables, includednested block scope symbol tables. If false, just flatten the script's or function's symbol table.
 */
void flattenSymbolTable(boolean flattenAllTables){
  if (!flattenAllTables) {
    ArrayList newSymbols=new ArrayList();
    if (this.symbolTable != null) {
      for (int i=0; i < symbols.size(); i++) {
        Symbol symbol=(Symbol)symbols.get(i);
        if (symbol.containingTable == this) {
          newSymbols.add(symbol);
        }
      }
    }
    symbols=newSymbols;
  }
  variableNames=new String[symbols.size()];
  isConsts=new boolean[symbols.size()];
  for (int i=0; i < symbols.size(); i++) {
    Symbol symbol=(Symbol)symbols.get(i);
    variableNames[i]=symbol.name;
    isConsts[i]=symbol.declType == Token.CONST;
    symbol.index=i;
  }
}
