/** 
 * Prepare for calling obj[id](...): return function corresponding to obj[id] and make obj properly converted to Scriptable available as ScriptRuntime.lastStoredScriptable() for consumption as thisObj. The caller must call ScriptRuntime.lastStoredScriptable() immediately after calling this method.
 */
public static Callable getElemFunctionAndThis(Object obj,Object elem,Context cx){
  String s=toStringIdOrIndex(cx,elem);
  if (s != null) {
    return getPropFunctionAndThis(obj,s,cx);
  }
  int index=lastIndexResult(cx);
  Scriptable thisObj=toObjectOrNull(cx,obj);
  if (thisObj == null) {
    throw undefCallError(obj,String.valueOf(index));
  }
  Object value;
  for (; ; ) {
    value=ScriptableObject.getProperty(thisObj,index);
    if (value != Scriptable.NOT_FOUND) {
      break;
    }
    if (!(thisObj instanceof XMLObject)) {
      break;
    }
    XMLObject xmlObject=(XMLObject)thisObj;
    Scriptable extra=xmlObject.getExtraMethodSource(cx);
    if (extra == null) {
      break;
    }
    thisObj=extra;
  }
  if (!(value instanceof Callable)) {
    throw notFunctionError(value,elem);
  }
  storeScriptable(cx,thisObj);
  return (Callable)value;
}
