/** 
 * Get listener at <i>index</i> position in <i>bag</i> or null if <i>index</i> equals to number of listeners in <i>bag</i>. <p> For usage example, see  {@link #addListener(Object bag,Object listener)}.
 * @param bag Current collection of listeners.
 * @param index Index of the listener to access.
 * @return Listener at the given index or null.
 * @see #addListener(Object bag,Object listener)
 * @see #removeListener(Object bag,Object listener)
 */
public static Object getListener(Object bag,int index){
  if (index == 0) {
    if (bag == null)     return null;
    if (!(bag instanceof Object[]))     return bag;
    Object[] array=(Object[])bag;
    if (array.length < 2)     throw new IllegalArgumentException();
    return array[0];
  }
 else   if (index == 1) {
    if (!(bag instanceof Object[])) {
      if (bag == null)       throw new IllegalArgumentException();
      return null;
    }
    Object[] array=(Object[])bag;
    return array[1];
  }
 else {
    Object[] array=(Object[])bag;
    int L=array.length;
    if (L < 2)     throw new IllegalArgumentException();
    if (index == L)     return null;
    return array[index];
  }
}
