/** 
 * Returns the maximum stack depth (in terms of number of call frames)  allowed in a single invocation of interpreter. If the set depth would be exceeded, the interpreter will throw an EvaluatorException in the script. Defaults to Integer.MAX_VALUE. The setting only has effect for  interpreted functions (those compiled with optimization level set to -1). As the interpreter doesn't use the Java stack but rather manages its own stack in the heap memory, a runaway recursion in interpreted code would  eventually consume all available memory and cause OutOfMemoryError  instead of a StackOverflowError limited to only a single thread. This setting helps prevent such situations.
 * @return The current maximum interpreter stack depth.
 */
public final int getMaximumInterpreterStackDepth(){
  return maximumInterpreterStackDepth;
}
