/** 
 * Implementation of  {@link Context#hasFeature(int featureIndex)}. This can be used to customize  {@link Context} without introducingadditional subclasses.
 */
protected boolean hasFeature(Context cx,int featureIndex){
  int version;
switch (featureIndex) {
case Context.FEATURE_NON_ECMA_GET_YEAR:
    version=cx.getLanguageVersion();
  return (version == Context.VERSION_1_0 || version == Context.VERSION_1_1 || version == Context.VERSION_1_2);
case Context.FEATURE_MEMBER_EXPR_AS_FUNCTION_NAME:
return false;
case Context.FEATURE_RESERVED_KEYWORD_AS_IDENTIFIER:
return false;
case Context.FEATURE_TO_STRING_AS_SOURCE:
version=cx.getLanguageVersion();
return version == Context.VERSION_1_2;
case Context.FEATURE_PARENT_PROTO_PROPERTIES:
return true;
case Context.FEATURE_E4X:
version=cx.getLanguageVersion();
return (version == Context.VERSION_DEFAULT || version >= Context.VERSION_1_6);
case Context.FEATURE_DYNAMIC_SCOPE:
return false;
case Context.FEATURE_STRICT_VARS:
return false;
case Context.FEATURE_STRICT_EVAL:
return false;
case Context.FEATURE_LOCATION_INFORMATION_IN_ERROR:
return false;
case Context.FEATURE_STRICT_MODE:
return false;
case Context.FEATURE_WARNING_AS_ERROR:
return false;
case Context.FEATURE_ENHANCED_JAVA_ACCESS:
return false;
}
throw new IllegalArgumentException(String.valueOf(featureIndex));
}
