/** 
 * The in operator. This is a new JS 1.3 language feature.  The in operator mirrors the operation of the for .. in construct, and tests whether the rhs has the property given by the lhs.  It is different from the for .. in construct in that: <BR> - it doesn't perform ToObject on the right hand side <BR> - it returns true for DontEnum properties.
 * @param a the left hand operand
 * @param b the right hand operand
 * @return true if property name or element number a is a property of b
 */
public static boolean in(Object a,Object b,Context cx){
  if (!(b instanceof Scriptable)) {
    throw typeError0("msg.instanceof.not.object");
  }
  return hasObjectElem((Scriptable)b,a,cx);
}
