/** 
 * Set the LiveConnect access filter for this context. <p>  {@link ClassShutter} may only be set if it is currently null.Otherwise a SecurityException is thrown.
 * @param shutter a ClassShutter object
 * @throws SecurityException if there is already a ClassShutterobject for this Context
 */
public final void setClassShutter(ClassShutter shutter){
  if (sealed)   onSealedMutation();
  if (shutter == null)   throw new IllegalArgumentException();
  if (classShutter != null) {
    throw new SecurityException("Cannot overwrite existing " + "ClassShutter object");
  }
  classShutter=shutter;
}
