/** 
 * Set the language version. <p> Setting the language version will affect functions and scripts compiled subsequently. See the overview documentation for version-specific behavior.
 * @param version the version as specified by VERSION_1_0, VERSION_1_1, etc.
 */
public void setLanguageVersion(int version){
  if (sealed)   onSealedMutation();
  checkLanguageVersion(version);
  Object listeners=propertyListeners;
  if (listeners != null && version != this.version) {
    firePropertyChangeImpl(listeners,languageVersionProperty,new Integer(this.version),new Integer(version));
  }
  this.version=version;
}
