private void transform(ScriptOrFnNode tree){
  initOptFunctions_r(tree);
  int optLevel=compilerEnv.getOptimizationLevel();
  Hashtable possibleDirectCalls=null;
  if (optLevel > 0) {
    if (tree.getType() == Token.SCRIPT) {
      int functionCount=tree.getFunctionCount();
      for (int i=0; i != functionCount; ++i) {
        OptFunctionNode ofn=OptFunctionNode.get(tree,i);
        if (ofn.fnode.getFunctionType() == FunctionNode.FUNCTION_STATEMENT) {
          String name=ofn.fnode.getFunctionName();
          if (name.length() != 0) {
            if (possibleDirectCalls == null) {
              possibleDirectCalls=new Hashtable();
            }
            possibleDirectCalls.put(name,ofn);
          }
        }
      }
    }
  }
  if (possibleDirectCalls != null) {
    directCallTargets=new ObjArray();
  }
  OptTransformer ot=new OptTransformer(possibleDirectCalls,directCallTargets);
  ot.transform(tree);
  if (optLevel > 0) {
    (new Optimizer()).optimize(tree);
  }
}
