/** 
 * Unseal previously sealed Context object. The <tt>sealKey</tt> argument should not be null and should match <tt>sealKey</tt> suplied with the last call to {@link #seal(Object)} or an exception will be thrown.
 * @see #isSealed()
 * @see #seal(Object sealKey)
 */
public final void unseal(Object sealKey){
  if (sealKey == null)   throw new IllegalArgumentException();
  if (this.sealKey != sealKey)   throw new IllegalArgumentException();
  if (!sealed)   throw new IllegalStateException();
  sealed=false;
  this.sealKey=null;
}
