package mining.bugreports;

import java.io.File;
import java.io.IOException;
import org.apache.commons.io.FileUtils;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import mining.commits.Helper;

import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;

public class Mining {
	
	public static String xmlURL = "https://issues.apache.org/jira/si/jira.issueviews:issue-xml/";
	
	public static String inputFilePath = "/Users/assist/dataset/TCM/resources/params/bugnbuffer.txt";
	public static String outputFilePath = "/Users/assist/dataset/TCM/resources/params/bugreportbuffer.txt";
	
	public static String start(String searchQuery) throws IOException{
		try {
		Document doc = Jsoup.connect(searchQuery).get();
		
		Elements descs = doc.getElementsByTag("item");	// there is only 1 item
		
		String title = descs.get(0).getElementsByTag("title").text(); 
		
		String description = descs.get(0).getElementsByTag("description").text();
		
		String status = descs.get(0).getElementsByTag("resolution").text();
		
		String type = descs.get(0).getElementsByTag("type").text();
		
		String assignee = descs.get(0).getElementsByTag("assignee").text();
		
		String reporter = descs.get(0).getElementsByTag("reporter").text();
		
		String priority = descs.get(0).getElementsByTag("priority").text();
		
		String created_date = descs.get(0).getElementsByTag("created").text();
		
		String resolved_date = descs.get(0).getElementsByTag("resolved").text();
		
		String component = descs.get(0).getElementsByTag("component").text();
		
		System.out.println("------------------------------------");
		String s = "Title: " + title + "\n";
		s += "Description: " + description + "\n"; 
		s += "Component: " + component + "\n";
		s += "Type: " + type + "\n";
		s += "Reporter: " + reporter + "\n"; 
		s += "Assignee: " + assignee + "\n"; 
		s += "Status: " + status + "\n";
		s += "Priority: " + priority + "\n";
		s += "Created: " + created_date + "\n";
		s += "Resolved: " + resolved_date;
		System.out.println(s);
		System.out.println("------------------------------------");
		
//		if (status.equalsIgnoreCase("fixed"))
//			return ("::: " + title + "\n\n" + "::: " + description);
//	
//		return "0"; // unresolved
		
		//return s;
		
		return ("::: " + title + "\n\n" + "::: " + description);
		
		} catch (Exception e) {
			e.printStackTrace();
			return "-1"; // bad bug tracking number -> exceptions rised
			
		}
	}
	
	public static void main(String[] args) throws IOException {
		// TODO Auto-generated method stub
		
//		String bugNumber = args[0].toUpperCase();
//		String outputFile = args[1];
		
//		String bugNumber = "LUCENE-2490";
//		String outputFile = "/Users/assist/ndataset/LUCENE-2490.txt";
//
//		
//		String query = xmlURL + bugNumber+"/" + bugNumber + ".xml";
//		
//		String result = start(query);
//		
//		if (result.trim().equals("0") || result.trim().equals("-1")) {
//			System.out.println("invalid bug report");
//		} else {
//			Helper.writeStringtoFile(outputFile, result);
//		}
		
		String bug_list_file = "/Users/assist/ndataset/dlo/projects/bugs-list/ant/ant_bug_list.txt";
		String out_dir = "/Users/assist/ndataset/dlo/projects/bug-reports/ant";
		FileUtils.cleanDirectory(new File(out_dir)); 
		
		ArrayList<String> refs = (ArrayList<String>) Helper.readFile(bug_list_file);
		
//		for (int i=0; i< refs.size(); i++){
//			System.out.println(refs.get(i));
//			String rev = refs.get(i).split(":")[0].trim();
//			String ref = refs.get(i).split(":")[1].trim();
//			String query = xmlURL + ref +"/" + ref + ".xml";
//			String report = start(query);
//			System.out.println(report);
//			Helper.writeStringtoFile(out_dir + "/" + rev + "_" + ref, report);
//		}
		
		for (int i=0; i< refs.size(); i++){
			String ref = refs.get(i).trim();
			String query = xmlURL + ref +"/" + ref + ".xml";
			String report = start(query);
			System.out.println(report);
			Helper.writeStringtoFile(out_dir + "/" + ref, report);
		}
		
	}

}
