package rtp.extractor;

import java.io.BufferedWriter;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Iterator;
import java.util.List;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.jdt.core.dom.AST;
import org.eclipse.jdt.core.dom.ASTNode;
import org.eclipse.jdt.core.dom.ASTParser;
import org.eclipse.jdt.core.dom.CompilationUnit;
import org.eclipse.jface.text.BadLocationException;
import org.eclipse.jface.text.Document;

import rtp.utility.FileSystem;

public class ClassExtractorStructured {
	private static Document fDocument;
	
	public static void main(String args[]) throws CoreException, IOException{
		System.out.println("Invoking comment extractor mehod");
		
		FileSystem fs = new FileSystem();
		String version = "0.61";
		//String codeDirectory = "/Users/ripon/RTS/subjects-ripon/commons-lang3.02/src/test/java3.02";
		//String codeDirectory = "/Users/ripon/RTS/subjects-ripon/jaxen1.1b9/src/java/test1.9";
		//String codeDirectory = "/Users/ripon/RTS/subjects-ripon/joda-time"+version+"/src/test"+version;
		//String codeDirectory = "/Users/ripon/RTS/subjects-ripon/timeandmoney4.0/tests/src4.0";
		//String codeDirectory = "/Users/ripon/RTS/subjects-ripon/jaxen"+version+"/src/test"+version;
		//String codeDirectory = "/Users/ripon/RTS/subjects-ripon/mime4j0.61/src/test/java0.61";
		//String codeDirectory = "/Users/ripon/RTS/subjects-ripon/xstream"+version+"/src/test"+version;
		//String codeDirectory = "/Users/ripon/RTS/subjects-ripon/xmlsec1.0/src_unitTests1";
		//String outputDir = "/Users/ripon/RTS/result/mime4j"+version+"/class-doc-structured";
		
		//String codeDirectory = "/Users/ripon/aspectj/trunk/org.aspectj";
		
//		String codeDirectory = "/Users/ripon/RTS/subjects-ripon/Ant6.0/src/testcases6";
//		String outputDir = "/Users/ripon/RTS/result/Ant6.0/class-doc-structured";

//		String codeDirectory = "/Users/assist/ndataset/mahout";
//		String outputDir = "/Users/assist/dataset/rtp/dataset/aries/structured-classes/MAHOUT-75-141e4c3d68a0045fe854d9c1ed73e184de2da87b";
		
//		String codeDirectory = args[0];
//		String outputDir = args[1];
		
//		String paramsFile = "/Users/assist/dataset/rtp/params/extractor.txt";
//		String params = FileSystem.readFile(paramsFile);
//		String codeDirectory = params.split("\n")[0];
//		String outputDir = params.split("\n")[1];
		
		String codeDirectory = args[0];
		String outputDir = args[1];
		
		
		System.out.println(codeDirectory);
		System.out.println(outputDir);
		
		int offset = codeDirectory.length();
		List<String> files = fs.getAllJavaFiles(codeDirectory, codeDirectory.length());
		Iterator <String> it = files.iterator();
		
		int count = 1;
		int fileCount = 0;
		System.out.println("Processing");
		while(it.hasNext()){
			
			fileCount++;

		String filePath = it.next();
		System.out.println(fileCount+"\t"+filePath);
//		if(count<4824){
//			count++;
//			continue;
//		}
		
		
		 


		String classFQN = filePath.substring(offset+1).replaceAll("/",".");
		String part[]= classFQN.split("\\.");
		String className = part[part.length-2];
		
		

	    	    String key = "";
	    	    
	    	    String fileName = "/class-"+count;
	    	    
	    		File file = new File(outputDir+fileName);

	    		// if file doesnt exists, then create it
	    		if (!file.exists()) {
	    			file.createNewFile();
	    		}

	    		FileWriter fw = new FileWriter(file.getAbsoluteFile());
	    		BufferedWriter bw = new BufferedWriter(fw);
	    	    
	    		
	    	    key = classFQN.substring(0, classFQN.length()-5);
	    	    
	    	    bw.write("<DOC>\n\t<DOCNO>"+key+" </DOCNO>\n\t<TEXT>");
	        	bw.newLine();
	        	
	       		ASTParser parser = ASTParser.newParser(AST.JLS3);		
	    		String source = FileSystem.readFile(filePath);
	    		
	    		parser.setSource(source.toCharArray());
	    		parser.setKind(ASTParser.K_COMPILATION_UNIT);
	    		final CompilationUnit cu = (CompilationUnit) parser.createAST(null);
	    		
	    		GenericVisitorFact visitor = new GenericVisitorFact();
	    		cu.accept(visitor);
	    		
	    		List<String> classes =  visitor.getClassNames();
	    		
	        	bw.write("<class>");        
	        	bw.newLine();
	        	for(String cls:classes){
	            	bw.write(cls);
	            	bw.newLine();
	        	    
	            	bw.write(PreProcessor.transform(cls));
	            	bw.newLine();
	        	}       	
	        	bw.write("</class>");
	        	bw.newLine();
	        	
	        	List<String> methods = visitor.getMethodNames();
	        	
	        	bw.write("<method>");  
	        	bw.newLine();
	        	
	        	if(methods.size() == 0){
		        	bw.write("NONE");  
		        	bw.newLine();
	        	}
	        	for(String methodName:methods){
	            	bw.write(methodName);
	            	bw.newLine();
	            	bw.write(PreProcessor.transform(methodName));
	            	bw.newLine();
	        	}       	
	        	bw.write("</method>");
	        	bw.newLine();
	        	
	        	List<String> idNames = visitor.getIdentifierNames();
	        	
	        	bw.write("<identifier>");   
	        	bw.newLine();
	        	for(String idName:idNames){
	            	bw.write(idName);
	            	bw.newLine();
	            	bw.write(PreProcessor.transform(idName));
	            	bw.newLine();
	        	}       	
	        	bw.write("</identifier>");
	        	bw.newLine();
	        	
	        	List<ASTNode> list = cu.getCommentList();
	        	bw.write("<comments>");   
	        	bw.newLine();
	        	
	        	fDocument = new Document(source);
	        	
	        	for(int i=0;i<list.size();i++){        		
	    	    	bw.write(PreProcessor.process(getCommentString(list.get(i))));
	    	    	bw.newLine();
	    	    }
	           
	        	bw.write("</comments>");   
	        	bw.newLine();       	
	        	bw.write("</text>\n</DOC>");
	        	bw.newLine();
	    	    bw.close();
	    	    count++;
	    	}    
		
	    System.out.println("End");
	}
	
    private static String getCommentString(ASTNode node) {
        try {
            return fDocument.get(node.getStartPosition(), node.getLength());
        } catch (BadLocationException e) {
            e.printStackTrace();
        }
        return null;
    }
    

}

