package rtp.extractor;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.eclipse.jdt.core.dom.AST;
import org.eclipse.jdt.core.dom.ASTParser;
import org.eclipse.jdt.core.dom.CompilationUnit;

import rtp.utility.FileSystem;

public class Core {
	 Set<String> getKeywords(String codeDirectory, String subject) throws IOException{
		 
			String lingmingResultPath = "/Users/ripon/RTS/lingming-results/untreated-tc/"+subject+".txt";
			Map<String,String> lingmingResults = new HashMap<String, String>();
			BufferedReader br = null;
			boolean check = true;
			if(!codeDirectory.contains("test")){
				check = false;
			}
			else{
			
				try{
					br = new BufferedReader(new FileReader(lingmingResultPath));
					String str = br.readLine();
					while(str!=null){
						lingmingResults.put(str, "");
						str = br.readLine();
					}
					
					br.close();
				}
				catch(Exception e){
					//System.out.println("file not found");
					check = false;
				}
			}

			

			Set<String> output = new HashSet<String>();
			
			FileSystem fs = new FileSystem();
			//int offset = codeDirectory.length();
			List<String> files = fs.getAllJavaFiles(codeDirectory, codeDirectory.length());
			Iterator <String> it = files.iterator();
			
			
			int fileCount = 0;
			
			
			while(it.hasNext()){		
				
				String filePath = it.next();
				if(!filePath.endsWith(".java")){
					continue;
				}
				
				//System.out.println(fileCount+"\t"+filePath);
				String key = "";
				
				if(check){
					int offset = codeDirectory.length();
					String classFQN = filePath.substring(offset+1).replaceAll("/",".");
					key = classFQN.substring(0, classFQN.length()-5);
					if(!lingmingResults.containsKey(key)){
						continue;
					}
				}
				fileCount++;
	       		ASTParser parser = ASTParser.newParser(AST.JLS3);		
	    		String source = FileSystem.readFile(filePath);
	    		
	    		parser.setSource(source.toCharArray());
	    		parser.setKind(ASTParser.K_COMPILATION_UNIT);
	    		final CompilationUnit cu = (CompilationUnit) parser.createAST(null);
	    		
	    		GenericVisitorFact visitor = new GenericVisitorFact();
	    		cu.accept(visitor);
	    		
	        	List<String> idNames = visitor.getIdentifierNames();
	        	
	        	for(String idName:idNames){
//	        		if(idName.length()>2){
//	        			output.add(idName.toLowerCase());
//	        		}
	            	
	            	String tokens = PreProcessor.transform(idName);
	            	String token[] = tokens.split(" ");
	            	for(int i=0;i<token.length;i++){
	            		output.add(token[i].trim());
	            	}
	        	}       	
	    	   
	    	} 
			
			//System.out.println("Processing: "+codeDirectory+" "+check+" #files: "+fileCount);
			return output;
		}
}
