package rtp.extractor;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.nio.MappedByteBuffer;
import java.nio.channels.FileChannel;
import java.nio.charset.Charset;
import java.util.Iterator;
import java.util.List;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.jdt.core.dom.AST;
import org.eclipse.jdt.core.dom.ASTNode;
import org.eclipse.jdt.core.dom.ASTParser;
import org.eclipse.jdt.core.dom.CompilationUnit;
import org.eclipse.jdt.core.dom.MethodDeclaration;
import org.eclipse.jdt.core.dom.TypeDeclaration;
import org.eclipse.jface.text.BadLocationException;
import org.eclipse.jface.text.Document;


import rtp.utility.FileSystem;

public class DocumentExtractor {
	private static Document fDocument;
	
	public static void main(String args[]) throws CoreException, IOException{
		System.out.println("Invoking comment extractor mehod");
		
		FileSystem fs = new FileSystem();
		String version = "3.03";
		//String codeDirectory = "/Users/ripon/RTS/subjects-ripon/commons-lang"+version+"/src/test/java"+version;
		//String codeDirectory = "/Users/ripon/RTS/subjects-ripon/jaxen"+version+"/src/java/test1.9";
		//String codeDirectory = "/Users/ripon/RTS/subjects-ripon/joda-time"+version+"/src/test"+version;
		//String codeDirectory = "/Users/ripon/RTS/subjects-ripon/timeandmoney"+version+"/tests/src"+version;
		//String codeDirectory = "/Users/ripon/RTS/subjects-ripon/mime4j0.50/src/test/java0.50";
		//String codeDirectory = "/Users/ripon/RTS/subjects-ripon/xstream"+version+"/src/test"+version;
		//String codeDirectory = "/Users/ripon/RTS/subjects-ripon/xmlsec1.0/src_unitTests1";
		//String outputDir = "/Users/ripon/RTS/result/commons-lang"+version+"/unparsed-doc";
		
		String codeDirectory = "/Users/ripon/RTS/subjects-ripon/Ant6.0/src/testcases6";
		String outputDir = "/Users/ripon/RTS/result/Ant6.0/unparsed-doc";

		//String codeDirectory = "/Users/ripon/aspectj/trunk/org.aspectj";
		
		
		
		int offset = codeDirectory.length();
		List<String> files = fs.getAllJavaFiles(codeDirectory, codeDirectory.length());
		Iterator <String> it = files.iterator();
		
		int count = 1;
		int fileCount = 0;
		System.out.println("Processing");
		while(it.hasNext()){
			
			fileCount++;

		String filePath = it.next();
		System.out.println(fileCount+"\t"+filePath);
//		if(count<4824){
//			count++;
//			continue;
//		}
		
		
		 


		String classFQN = filePath.substring(offset+1).replaceAll("/",".");
		String part[]= classFQN.split("\\.");
		String className = part[part.length-2];
		
		
		ASTParser parser = ASTParser.newParser(AST.JLS3);
		
		String source = FileSystem.readFile(filePath);
		
		//System.out.println(source);
		
		parser.setSource(source.toCharArray());
		parser.setKind(ASTParser.K_COMPILATION_UNIT);
		final CompilationUnit cu = (CompilationUnit) parser.createAST(null);
	    
	  	    		
	    	    List<ASTNode> list = cu.getCommentList();
	    	    String key = "";
	    	    
	    	    String fileName = "/class-"+count;
	    	    
	    		File file = new File(outputDir+fileName);

	    		// if file doesnt exists, then create it
	    		if (!file.exists()) {
	    			file.createNewFile();
	    		}

	    		FileWriter fw = new FileWriter(file.getAbsoluteFile());
	    		BufferedWriter bw = new BufferedWriter(fw);
	    	    
	    		
	    	    key = classFQN.substring(0, classFQN.length()-5);
	    	    
	    	    bw.write("<DOC>\n\t<DOCNO>"+key+" </DOCNO>\n\t<TEXT>");
	        	bw.newLine();
	        	
	        	bw.write(PreProcessor.process(source));
	        	bw.write("\t</TEXT>\n</DOC>");
	        	bw.newLine();
	    	    bw.close();
	    	    count++;
	    	}    
		
	    System.out.println("End");
	}
	
    private static String getCommentString(ASTNode node) {
        try {
            return fDocument.get(node.getStartPosition(), node.getLength());
        } catch (BadLocationException e) {
            e.printStackTrace();
        }
        return null;
    }
    

}

