package rtp.extractor;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import org.eclipse.jdt.core.dom.AST;
import org.eclipse.jdt.core.dom.ASTNode;
import org.eclipse.jdt.core.dom.ASTParser;
import org.eclipse.jdt.core.dom.CompilationUnit;
import org.eclipse.jface.text.Document;

import rtp.utility.FileSystem;

public class SourceCodeKeyWordExtractor {

	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		// TODO Auto-generated method stub
		String sourceCodeDirInfo = "/Users/ripon/RTS/sourcepath.txt";
		String outputDirSrc = "/Users/ripon/RTS/source-ids";
		String outputDirTest = "/Users/ripon/RTS/test-ids";
		
		Core core = new Core();
		
		BufferedReader br = new BufferedReader(new FileReader(sourceCodeDirInfo));

		
		String str = br.readLine();
		
		while(str != null){
			String parts[] = str.split(" ");
 			String sourceCodePath = parts[0];
 			String testCodePath = parts[1];
			String subjectPath = sourceCodePath.substring("/Users/ripon/RTS/subjects-ripon/".length());
			String subjectName = subjectPath.split("/")[0];
			Set<String> idsource = core.getKeywords(sourceCodePath,subjectName);
			//System.out.println("#Ids in Source: "+idsource.size());
			Set<String> idtest = core.getKeywords(testCodePath,subjectName);
			int idtestSize = idtest.size();
			//System.out.println("#Ids in Tests: "+idtest.size());
			idtest.retainAll(idsource);
			//System.out.println("#Ids in Common: "+idtest.size()+" ");

			System.out.println(subjectName+"\t"+idsource.size()+"\t"+idtestSize+"\t"+idtest.size()+"\t"+((double) idtest.size()/ (double)idtestSize));
			

//			BufferedWriter bw = new BufferedWriter(new FileWriter(outputDirTest+"/"+subjectName+".txt"));
//			for(String id : idtest){
//				bw.write(id);
//				bw.newLine();
//			}
//			bw.close();
			str = br.readLine();
		}
	}
}
