package rtp.result;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import rtp.utility.FileSystem;


public class ClassAPFDLing {

	/**
	 * @param args
	 * @throws IOException 
	 */
	static int n = 15;
	
	public static void main (String[] args) throws IOException {
		//FileSystem fs = new FileSystem();
		boolean print = true;

		String ftResultPath = "/Users/ripon/RTS/fault-info/xmlsec1.0-xmlsec2.0-fault-info.data";;
		

		String path = "/Users/ripon/RTS/filtered-class-results/";
		

		
		//List<String> files = FileSystem.getAllFiles(path, path.length()-1);
		
		//**for untreated test results
		List<String> files = new ArrayList<String>();
		files.add("xmlsec1.0-result_tfidf-raw-class-structured-filtered.txt");
		//
		
		double apfd[] = new double[files.size()];
		
		int f = 0;
		
		for(String file:files){
		
				String ourResultPath = path+file;
		
		System.out.println(ftResultPath);
		System.out.println(ourResultPath);
		System.out.println("-----------------------------------------------------------------------------------\n");
		
		
		Map<String, List<Integer>> faults = new HashMap<String, List<Integer>>();
		
		BufferedReader br = new BufferedReader(new FileReader(ftResultPath));
		String str = br.readLine();
		
		int i = 1;
		
		Map<String, Integer> faultyTestCasesPos = FaultyTestCases.getClassPositionLingming(ftResultPath, ourResultPath,print);
		
		while(str!=null){
			String parts[] = str.split("-");
			//String testCaseName = parts[0].substring(6);
			//System.out.println(testCaseName);
			String changes[] = parts[1].split(",");
			for(int j = 0; j<changes.length; j++){
				Integer pos = faultyTestCasesPos.get(""+i);
				if(pos != null){
					add(faults, changes[j], pos);
				}
			}
			str = br.readLine();
			i++;
		}
		
		br.close();
		
		apfd[f] = print(faults);
		f++;
		}
		
		DecimalFormat df = new DecimalFormat("#.##");
		 
		for(double apfd_cur: apfd){
			System.out.print(df.format(apfd_cur)+"\t");
		}
		double sum = 0;
		for(double apfd_cur: apfd){
			sum = sum + apfd_cur;
		}
		
		System.out.println("\n\nAverage: "+df.format(sum/apfd.length));
		

	}
	
	static void add(Map<String,List<Integer>> faults, String key, Integer str){
		if(faults.containsKey(key)){
			List<Integer> testCases = faults.get(key);
			testCases.add(str);
			faults.put(key, testCases);
		}
		else{
			List<Integer> testCases = new ArrayList<Integer>();
			testCases.add(str);
			faults.put(key, testCases);
		}
	}
	
	static double print(Map<String,List<Integer>> faults){
		int i = 0;
		int tf = 0;
		for (Map.Entry<String, List<Integer>> entry : faults.entrySet()) {
		    String key = entry.getKey();
		    //System.out.println("\t"+key+"--->"+faults.get(key)+"--->"+Collections.min(faults.get(key)));
		    int min = Collections.min(faults.get(key));
		    tf = tf + min;
		    System.out.println(++i+"\t"+faults.get(key)+"\t"+ min);
		}
		
		System.out.println();
		
		int nm = n*faults.size();
		
		System.out.println("tf\t"+tf);
		System.out.println("nm\t"+ nm);
		
		double apfd = 1 - (double) tf / (double) nm + 1/(2*(double)n);
		
		System.out.println("APFD\t"+apfd+"\n\n");
		
		return apfd;
	}
}
