package rtp.result;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import rtp.utility.FileSystem;


public class CopyOfClassAPFD {

	/**
	 * @param args
	 * @throws IOException 
	 */
	static int n = 27;
	
	public static void main (String[] args) throws IOException {
		//FileSystem fs = new FileSystem();
		String ftResultPath = "/Users/ripon/RTS/fault-info/xmlsec1.0-xmlsec2.0-fault-info.data";
		String ourResultPath = "/Users/ripon/RTS/result/xmlsec1.0/result_tfidf-class";
		
		//System.out.println(ftResultPath);
		Map<String, List<Integer>> faults = new HashMap<String, List<Integer>>();
		
		BufferedReader br = new BufferedReader(new FileReader(ftResultPath));
		String str = br.readLine();
		
		int i = 1;
		
		Map<String, Integer> faultyTestCasesPos = FaultyTestCases.getClassPosition(ftResultPath, ourResultPath);
		
		while(str!=null){
			String parts[] = str.split("-");
			//String testCaseName = parts[0].substring(6);
			//System.out.println(testCaseName);
			String changes[] = parts[1].split(",");
			for(int j = 0; j<changes.length; j++){
				Integer pos = faultyTestCasesPos.get(""+i);
				if(pos != null){
					add(faults, changes[j], pos);
				}
			}
			str = br.readLine();
			i++;
		}
		
		print(faults);
		
		
		

	}
	
	static void add(Map<String,List<Integer>> faults, String key, Integer str){
		if(faults.containsKey(key)){
			List<Integer> testCases = faults.get(key);
			testCases.add(str);
			faults.put(key, testCases);
		}
		else{
			List<Integer> testCases = new ArrayList<Integer>();
			testCases.add(str);
			faults.put(key, testCases);
		}
	}
	
	static void print(Map<String,List<Integer>> faults){
		int i = 0;
		int tf = 0;
		for (Map.Entry<String, List<Integer>> entry : faults.entrySet()) {
		    String key = entry.getKey();
		    //System.out.println("\t"+key+"--->"+faults.get(key)+"--->"+Collections.min(faults.get(key)));
		    int min = Collections.min(faults.get(key));
		    tf = tf + min;
		    System.out.println(++i+"\t"+faults.get(key)+"\t"+ min);
		}
		
		System.out.println();
		
		int nm = n*faults.size();
		
		System.out.println("tf\t"+tf);
		System.out.println("nm\t"+ nm);
		
		double apfd = 1 - (double) tf / (double) nm + 1/(2*(double)n);
		
		System.out.println("APFD\t"+apfd);
	}
}
