package rtp.utility;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.nio.MappedByteBuffer;
import java.nio.channels.FileChannel;
import java.nio.charset.Charset;
import java.util.ArrayList;
import java.util.List;

public class FileSystem {
	 List<String> files  = new ArrayList<String>();
	int i = 0;
	
	public List<String> getAllJavaFiles(String path,int offset) throws IOException{
		 
		File[] faFiles = new File(path).listFiles();
		
		for(File file: faFiles){
			//System.out.println(file.getName());
			if(file.getName().endsWith(".java")){
				files.add(file.getAbsolutePath());
				//System.out.println(file.getAbsolutePath());
				//.substring(offset+1).replaceAll("/",".")
			}
			if(file.isDirectory()){
				//sSystem.out.println(file.getAbsolutePath());
				getAllJavaFiles(file.getAbsolutePath(),offset);
			}
		}
		return files;
	}

	
	public List<String> getAllZipFiles(String path,int offset) throws IOException{
		 
		File[] faFiles = new File(path).listFiles();
		for(File file: faFiles){
			//System.out.println(file.getAbsoluteFile());
			if(file.getName().endsWith(".zip")){
				files.add(file.getAbsolutePath());
				//.substring(offset+1).replaceAll("/",".")
			}
			if(file.isDirectory()){
				getAllZipFiles(file.getAbsolutePath(),offset);
			}
		}
		return files;
	}
	
	public  List<String> getAllFiles(String path,int offset) throws IOException{
		files  = new ArrayList<String>();
		File[] faFiles = new File(path).listFiles();
		for(File file: faFiles){
			
				files.add(file.getAbsolutePath().substring(offset+1));
		}
		return files;
	}
	
	
    
    public static String readFile(String path) throws IOException {
    	  FileInputStream stream = new FileInputStream(new File(path));
    	  try {
    	    FileChannel fc = stream.getChannel();
    	    MappedByteBuffer bb = fc.map(FileChannel.MapMode.READ_ONLY, 0, fc.size());
    	    /* Instead of using default, pass in a decoder. */
    	    return Charset.defaultCharset().decode(bb).toString();
    	  }
    	  finally {
    	    stream.close();
    	  }
    	}

	
	
	public static void main(String args[]) throws IOException{
		//FileSystem fs = new FileSystem();
//		String path = "/Users/assist/rtp/dataset/subject_data/apache-ant-1.9.5/src";
//		System.out.println(fs.getAllJavaFiles(path,path.length()).size());
		
		String fileName = "/Users/assist/ndataset/dlo/projects/coverage-data/lucene/class-cv/LUCENE-1250.txt";
		String[] filteredClasses = FileSystem.readFile(fileName).split("\n");
		for (int i=0; i< filteredClasses.length; i++) {
			filteredClasses[i] = filteredClasses[i].split(":")[0];
		}
		
		for (int i=0; i< filteredClasses.length; i++) {
			System.out.println(filteredClasses[i]);
		}
		
	}
	
	

}
