
package rtp.utility;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.runtime.CoreException;


//@SuppressWarnings("restriction")
public final class StructureDiffUtils {

    private static final int BUFFER_LENGTH = 1024;


    private StructureDiffUtils() {}

    /**
     * Compares two {@link IFile}s with each other by using the Eclipse compare facilities and returns the root
     * {@link DiffNode} of the differences.
     * 
     * @param left
     *            file to compare
     * @param right
     *            file to compare
     * @return the root diff node of the differences
     * @throws FileNotFoundException 
     */
    
    public static String readFile(String filePath) throws CoreException, FileNotFoundException {
        char[] b = new char[BUFFER_LENGTH];
        InputStreamReader isr = null;
        isr = new InputStreamReader(new FileInputStream(filePath));
        StringBuffer sb = new StringBuffer();
        int n;
        try {
            while ((n = isr.read(b)) > 0) {
                sb.append(b, 0, n);
            }
            isr.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
        return sb.toString();
    }
    
}
