package td.brclassifier;

import java.util.List;

public class Bug {
	private String id;
	private String summary;
	private String description;
	private List<String> stackTraces;
	private String nonStackTraceContent;
	private boolean containStackTrace;
	
	/**
	 * check if the description contains a stack trace, and
	 * initialize the appropriate properties
	 */
	private void realizeStackTraces() {
		if (getDescription() != null) {
			if (BrParser.containsStackTrace(getDescription())) {
				setContainStackTrace(true);
				setStackTraces(BrParser.extractStackTraces(getDescription()));
				setNonStackTraceContent(BrParser.eliminateStackTraces(getDescription()));
			} else {
				setContainStackTrace(false);
			}
		}
	}
	
	public Bug(String _id, String _summary, String _desc){
		setId(_id);
		setSummary(_summary);
		setDescription(_desc);
		realizeStackTraces();
	}
	
	public Bug() {
		
	}
	
	public String getId() {
		return id;
	}
	public void setId(String id) {
		this.id = id;
	}
	public String getDescription() {
		return description;
	}
	public void setDescription(String description) {
		this.description = description;
	}

	public String getSummary() {
		return summary;
	}

	public void setSummary(String summary) {
		this.summary = summary;
	}

	public List<String> setStackTraces() {
		return stackTraces;
	}

	public void setStackTraces(List<String> stackTrace) {
		this.stackTraces = stackTrace;
	}

	public boolean containsStackTrace() {
		return containStackTrace;
	}

	public void setContainStackTrace(boolean containStackTrace) {
		this.containStackTrace = containStackTrace;
	}

	public String getNonStackTraceContent() {
		return nonStackTraceContent;
	}

	public void setNonStackTraceContent(String nonStackTraceContent) {
		this.nonStackTraceContent = nonStackTraceContent;
	}
}