package td.extractor;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.nio.MappedByteBuffer;
import java.nio.channels.FileChannel;
import java.nio.charset.Charset;
import java.util.Iterator;
import java.util.List;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.jdt.core.dom.AST;
import org.eclipse.jdt.core.dom.ASTNode;
import org.eclipse.jdt.core.dom.ASTParser;
import org.eclipse.jdt.core.dom.CompilationUnit;
import org.eclipse.jdt.core.dom.MethodDeclaration;
import org.eclipse.jdt.core.dom.TypeDeclaration;
import org.eclipse.jface.text.BadLocationException;
import org.eclipse.jface.text.Document;

import rtp.extractor.GenericVisitor;
import rtp.extractor.PreProcessor;
import rtp.utility.FileSystem;

public class MethodExtractor {
	private static Document fDocument;
	
	public static void main(String args[]) throws CoreException, IOException{
		System.out.println("Invoking comment extractor mehod");
		
		FileSystem fs = new FileSystem();
		String version = "6.0";
		String codeDirectory = "/Users/assist/dmz/filter-code/slicing/lucene37/LUCENE-1250";
		//String codeDirectory = "/Users/ripon/RTS/subjects-ripon/jaxen"+version+"/src/test"+version;
		String outputDir = "Users/assist/Desktop/LUCENE-1250-doc";
		
		//String codeDirectory = "/Users/ripon/aspectj/trunk/org.aspectj";
		
		
		
		int offset = codeDirectory.length();
		List<String> files = fs.getAllJavaFiles(codeDirectory, codeDirectory.length());
		Iterator <String> it = files.iterator();
		
		int count = 1;
		int fileCount = 0;
		System.out.println("Processing");
		while(it.hasNext()){
			
			fileCount++;

		String filePath = it.next();
		System.out.println(fileCount+"\t"+filePath);

		String classFQN = filePath.substring(offset+1).replaceAll("/",".");
		String part[]= classFQN.split("\\.");
		String className = part[part.length-2];
		
		
		ASTParser parser = ASTParser.newParser(AST.JLS3);
		
		String source = FileSystem.readFile(filePath);
		
		//System.out.println(source);
		
		parser.setSource(source.toCharArray());
		parser.setKind(ASTParser.K_COMPILATION_UNIT);
		final CompilationUnit cu = (CompilationUnit) parser.createAST(null);
	    
	    List<TypeDeclaration> classes =  cu.types();
	    
	    for(int i=0;i<classes.size();i++){
	    	TypeDeclaration curType = classes.get(i);
	    	
	    	System.out.println(curType.getName());
	    	
	    	MethodDeclaration[] methodList = curType.getMethods();
	    	for(int j=0; j<methodList.length; j++){
	    		MethodDeclaration cMethod = methodList[j];
	    		
	    		System.out.println(cMethod.toString());
	    		
//	    		ASTParser parserM = ASTParser.newParser(AST.JLS3);
//	    		parserM.setSource(cMethod.toString().toCharArray());
//	    		parserM.setKind(ASTParser.K_COMPILATION_UNIT);
//	    		final CompilationUnit cu1 = (CompilationUnit) parserM.createAST(null);
//	    		
//	    	    List<ASTNode> list = cu.getCommentList();
	    	    
	    	    String key = "";
	    	    
	    	    String fileName = "/method-"+count;
	    	    
	    		File file = new File(outputDir+fileName);

	    		// if file doesnt exists, then create it
	    		if (!file.exists()) {
	    			file.createNewFile();
	    		}

	    		FileWriter fw = new FileWriter(file.getAbsoluteFile());
	    		BufferedWriter bw = new BufferedWriter(fw);
	    	    
	    		
	    	    key = classFQN.substring(0, classFQN.length()-5)+"."+cMethod.getName();
	    	    
	    	    bw.write("<DOC>\n\t<DOCNO>"+key+" </DOCNO>\n\t<TEXT>");
	        	bw.newLine();
	        	
	        	bw.write(className);
	        	bw.newLine();
	    	    
	        	bw.write(PreProcessor.transform(className));
	        	bw.newLine();
	           
	        	fDocument = new Document(cMethod.toString());
	    		
	    
//	    		List <ASTNode> list1 = cu1.getCommentList();
//	    		
	  
//	    	    for(int k=0;k<list1.size();k++){
//	    	    	
//	    	    	//System.out.println("COMMENT:\n\n");
//	    	    	//System.out.println(list1.size());
//	    	    	//System.out.println(list1);
//	    	    	ASTNode cComment = list1.get(k);
//	    	    	String comStr = getCommentString(cComment);
//	    	    	bw.write(PreProcessor.process(comStr));
//	    	    	bw.newLine();
//	    	    }	
	    	    //bw.write("code");
	    	    //bw.newLine();
	    	    GenericVisitor visitor = new GenericVisitor(bw);
	    	    
	    	    try{
	    	    	bw.write(cMethod.getName().toString());
	    	    	bw.newLine();
	    	    	cMethod.accept(visitor);
	    	    }
	    	    catch(Exception e){
	    	    	e.printStackTrace();
	    	    }
	        	bw.write("\t</TEXT>\n</DOC>");
	        	bw.newLine();
	    	    bw.close();
	    	    count++;
	    	}
	    	
	    }    
		}
	    System.out.println("End");
	}
	
    private static String getCommentString(ASTNode node) {
        try {
            return fDocument.get(node.getStartPosition(), node.getLength());
        } catch (BadLocationException e) {
            e.printStackTrace();
        }
        return null;
    }
    

}