package td.utils;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.nio.charset.Charset;
import java.nio.charset.MalformedInputException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.stream.*;
import java.io.BufferedInputStream;

public class FileHandler {
	
	public static List<String> readAllLines(String filePath) throws IOException {
		try {
			List<String> lines = Files.readAllLines(Paths.get(filePath), Charset.forName("UTF-8")); //Charset.forName("UTF-8"));
			return lines;
		} catch (MalformedInputException e) {
			e.printStackTrace();
			System.out.println(e.getMessage());
			System.out.println(filePath);
		}
		return null;
	}
	
	public static int countLines(String filename) throws IOException {
	    InputStream is = new BufferedInputStream(new FileInputStream(filename));
	    try {
	        byte[] c = new byte[1024];
	        int count = 0;
	        int readChars = 0;
	        boolean empty = true;
	        while ((readChars = is.read(c)) != -1) {
	            empty = false;
	            for (int i = 0; i < readChars; ++i) {
	                if (c[i] == '\n') {
	                    ++count;
	                }
	            }
	        }
	        return (count == 0 && !empty) ? 1 : count;
	    } finally {
	        is.close();
	    }
	}
	
	public static void writeListToFile(List<String> list, String filePath) throws IOException {
		BufferedWriter writer = new BufferedWriter(new FileWriter(filePath)); 
		for(String line : list) {
		  writer.write(line);
		  writer.newLine();
		}
		writer.close();
	}
	
	
	public static void writeHashToFile(HashSet<String> hash, String filePath) throws IOException {
		BufferedWriter writer = new BufferedWriter(new FileWriter(filePath)); 
		for(String line : hash) {
		  writer.write(line);
		  writer.newLine();
		}
		writer.close();
	}
	
	public static void appendListToFile(String filePath, List<String> list) throws IOException{
		File file = new File(filePath);
		if (!file.exists()){
			file.createNewFile();
		}
		FileWriter fw = new FileWriter(file.getName(), true);
		BufferedWriter bw = new BufferedWriter(fw);
		
		for (String line : list) {
			bw.write(line);
		}
		bw.close();
		fw.close();
	}


}
