package td.utils;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class TestcaseGen {
	public static void updateFaulttracerXML(String faulltracerXmlFile, String testSet){
		try {
			DocumentBuilderFactory docFactory = DocumentBuilderFactory.newInstance();
			DocumentBuilder docBuilder = docFactory.newDocumentBuilder();
			Document doc = docBuilder.parse(faulltracerXmlFile);
			
			NodeList properties = doc.getElementsByTagName("property");
			
			for (int i=0; i< properties.getLength(); i++){
				Node propertyNode = properties.item(i);
				String propertyName = propertyNode.getAttributes().getNamedItem("name").getNodeValue();
				String propertyValue = propertyNode.getAttributes().getNamedItem("value").getNodeValue();
				
				if (propertyName.equals("testsuite")) {
					System.out.println(propertyName + "=" + propertyValue);
					propertyNode.getAttributes().getNamedItem("value").setTextContent(testSet);
					
					TransformerFactory transformerFactory = TransformerFactory.newInstance();
					Transformer transformer = transformerFactory.newTransformer();
					DOMSource source = new DOMSource(doc);
					StreamResult result = new StreamResult(new File(faulltracerXmlFile));
					transformer.transform(source, result);

					System.out.println("Done");
					
					break;
				}
				
			}
			
		} catch (Exception e){
			e.printStackTrace();
			System.out.println(faulltracerXmlFile);
			
		}
	}
	
	public static String getTestList(String testCaseFile){
		try {
			List<String> lines = FileHandler.readAllLines(testCaseFile);
			
			List<String> testClasses = new ArrayList<String>();
			
			for (int i=1; i<lines.size(); i++){
				testClasses.add(lines.get(i).split(",")[0].trim());
			}
			
			HashSet<String> uniqueTestClasses = new HashSet<>(testClasses);
			
			String testList = "";
			
			for (String test : uniqueTestClasses) {
				testList += test + ":";
			}
			
			return testList.substring(0, testList.length()-1);
			
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			System.out.println(testCaseFile);
			return null;
		}
	}
	
	public static String getTestList3(String testCaseFile){ //for rhino case
		try {
			List<String> lines = FileHandler.readAllLines(testCaseFile);
			
			List<String> testClasses = new ArrayList<String>();
			
			for (int i=0; i<lines.size(); i++){
				System.out.println(lines.get(i));
				testClasses.add(lines.get(i).split("\\/classes\\/")[1].replace("/", "."));
			}
			
			HashSet<String> uniqueTestClasses = new HashSet<>(testClasses);
			
			String testList = "";
			
			for (String test : uniqueTestClasses) {
				testList += test + ":";
				System.out.println(test);
			}
			
			String result = testList.substring(0, testList.length()-1);
			System.out.println(result);
			return result;
			
			
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			System.out.println(testCaseFile);
			return null;
		}
	}
	
	public static List<String> getTestList2(String testCaseFile){
		try {
			List<String> lines = FileHandler.readAllLines(testCaseFile);
			
			List<String> testClasses = new ArrayList<String>();
			
			for (int i=1; i<lines.size(); i++){
				testClasses.add(lines.get(i).split(",")[0].trim());
			}
			
			HashSet<String> uniqueTestClasses = new HashSet<>(testClasses);
			
			List<String> list = new ArrayList<String>();
			
			for (String c : uniqueTestClasses) {
				list.add(c);
			}
			
			return list;
			
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			System.out.println(testCaseFile);
			return null;
		}
	}
	
	
	public static void writeAllTests(String inputDir, String outputDir){
		File[] versions = new File(inputDir).listFiles();
		
		for (File f : versions) {
			if (f.exists() && f.isFile()) {
				List<String> testList = getTestList2(f.getAbsolutePath());
				try {
					FileHandler.writeListToFile(testList, outputDir + "/" + f.getName());
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
					System.out.println(f.getAbsolutePath());
					System.exit(0);
				}
			}
		}
	}
	
	public static void updateAllFaulttracerXMLFiles(String testCaseDir, String XmlDir){
		File[] versions = new File(XmlDir).listFiles();
		int count = 0;
		for (File file:versions){
			if (file.exists() && file.isDirectory()){
				String xmlFilePath = file.getAbsolutePath() + "/" + "post-fix/" + file.getName() + ".faulttracer.xml";
				String testCaseFilePath = testCaseDir + "/" + file.getName() + ".txt" ;
				
				if (new File(xmlFilePath).exists() && new File(testCaseFilePath).exists()) {
					//String testList = getTestList(testCaseFilePath);
					String testList = getTestList3(testCaseFilePath);
					updateFaulttracerXML(xmlFilePath, testList);
					
					System.out.println("[Done] " + ++count + xmlFilePath);
				} else {
					System.out.println("This file does not exist " + xmlFilePath);
				}
			}
		}
		
	}
	
	public static void updateCloverXML(String cloverXmlFile, String nValue){
		try {
			DocumentBuilderFactory docFactory = DocumentBuilderFactory.newInstance();
			DocumentBuilder docBuilder = docFactory.newDocumentBuilder();
			Document doc = docBuilder.parse(cloverXmlFile);
			
			NodeList javaNode = doc.getElementsByTagName("arg");
			
			if (javaNode.getLength() != 2) {
				System.out.println("[error] there must be two arg parameters");
				System.exit(0);
			}
			
			for (int i=0; i< javaNode.getLength(); i++){
				Node propertyNode = javaNode.item(i);
				String propertyName = propertyNode.getAttributes().getNamedItem("value").getNodeValue();
			
				if (! propertyName.equals("-logAll")) {
					
					//String newValue = "../tests/" + cloverXmlFile.split("\\/build\\/")[1].split("_build")[0] +  cloverXmlFile.split("\\/build\\/")[1].split("_build")[1];
					
					String newValue = "../tests/" + nValue;

					System.out.println("Old value: " + propertyName);
					System.out.println("New value: " + newValue);
					
					propertyNode.getAttributes().getNamedItem("value").setTextContent(newValue);
					
					TransformerFactory transformerFactory = TransformerFactory.newInstance();
					Transformer transformer = transformerFactory.newTransformer();
					DOMSource source = new DOMSource(doc);
					StreamResult result = new StreamResult(new File(cloverXmlFile));
					transformer.transform(source, result);

					System.out.println("Done update !" + cloverXmlFile);
					
					break;
					
				}
				
			}
			
		} catch (Exception e){
			e.printStackTrace();
			System.out.println(cloverXmlFile);
			
		}
		
	}
	
	public static void updateCloverXML2(String cloverXmlFile, String nValue){
		try {
			DocumentBuilderFactory docFactory = DocumentBuilderFactory.newInstance();
			DocumentBuilder docBuilder = docFactory.newDocumentBuilder();
			Document doc = docBuilder.parse(cloverXmlFile);
			
			NodeList javaNode = doc.getElementsByTagName("current");
			
			if (javaNode.getLength() != 1) {
				System.out.println("[error] there must be two arg parameters");
				System.exit(0);
			}
			
			for (int i=0; i< javaNode.getLength(); i++){
				Node propertyNode = javaNode.item(i);
				String propertyName = propertyNode.getAttributes().getNamedItem("outfile").getNodeValue();
				
				System.out.println("Old value = " + propertyName);
				
				propertyNode.getAttributes().getNamedItem("outfile").setTextContent("coverage_"+ nValue);
				
				System.out.println("New Value = " + nValue);
				
				TransformerFactory transformerFactory = TransformerFactory.newInstance();
				Transformer transformer = transformerFactory.newTransformer();
				DOMSource source = new DOMSource(doc);
				StreamResult result = new StreamResult(new File(cloverXmlFile));
				transformer.transform(source, result);

				System.out.println("Done update !" + cloverXmlFile);
				
				break;	
				
			}
			
		} catch (Exception e){
			e.printStackTrace();
			System.out.println(cloverXmlFile);
			
		}
		
	}
	
	public static void updateAllCloverBuildXmlFiles(){
		String inputDir = "/Users/assist/dmz/ir-dataset/code/aspectj";	
		
		File[] versions = new File(inputDir).listFiles();
		
		int count = 0;
		for (int i=0; i<versions.length; i++){
			if (versions[i].isDirectory()) {
				String versionPath = versions[i].getAbsolutePath();
				File[] buildFiles = new File(versionPath + "/post-fix/org.aspectj/modules/build").listFiles();
				for (File bf : buildFiles) {
					String buildFileName = bf.getName();
					String paramFileName = "";
					if (buildFileName.contains("passed_build")){
						paramFileName = "passed" + buildFileName.split("build")[1];
					} else if (buildFileName.contains("failed_build")) {
						paramFileName = "failed" + buildFileName.split("build")[1];
					} else {
						continue;
					}

					String testsPath = versionPath + "/post-fix/org.aspectj/modules/tests";

					File paramFile = new File (testsPath + "/" + paramFileName);
					if (paramFile.exists()) {
						System.out.println(++ count + ". " + buildFileName);
						System.out.println(paramFileName);
						
						updateCloverXML2(bf.getAbsolutePath(), paramFileName);
						
					} else {
						System.out.println("error >>> build file does not have a corresponding param file in tests folder");
						System.out.println(versionPath);
						System.out.println(buildFileName);
						System.out.println(paramFileName);
						System.exit(0);
					}
						
				}
			}
		}
		
		System.out.println("Done !");

	}

	public static void main(String[] args) {
		// TODO Auto-generated method stub
//		String test_cases_dir = "/Users/assist/dmz/src/rtp/DLo/amldata/test_cases_list/lucene";
//		String xml_dir = "/Users/assist/dmz/ir-dataset/code/lucene37";
		
//		String inputDir = "/Users/assist/dmz/src/rtp/DLo/amldata/test_cases_list/ant";
//		String outputDir = "/Users/assist/dmz/src/rtp/DLo/amldata/all_tests/ant";
//		
//		writeAllTests(inputDir, outputDir);
		
		
		//updateCloverXML("/Users/assist/dmz/ir-dataset/code/aspectj/100227/post-fix/org.aspectj/modules/build/passed_build_100227_1.xml");
		
		//updateAllCloverBuildXmlFiles();
		
		//getTestList3("/Users/assist/dmz/src/rtp/DLo/amldata/all_tests/rhino/RHINO-409702.txt");
		
		updateAllFaulttracerXMLFiles("/Users/assist/dmz/src/rtp/DLo/amldata/all_tests/rhino", "/Users/assist/dmz/ir-dataset/code/rhino");
		
	}

}
