#!bash/sh
project="$1"
bug_locator_path="/Users/assist/dmz/tools/BugLocator/BugLocator.jar"

bug_dir="/Users/assist/dmz/ir-dataset/bugs-xml-repository/$project"

#code_dir="/Users/assist/dmz/ir-dataset/code/$project"
#code_dir="/Users/assist/dmz/filter-code/coverage/$project"
code_dir="/Users/assist/dmz/filter-code/slicing/$project"

#output_dir="/Users/assist/dmz/gen-data/buglocator2/$project"
#output_dir="/Users/assist/dmz/gen-data/buglocator_and_cv/$project"
output_dir="/Users/assist/dmz/gen-data/buglocator_and_slicing/$project"

#slicing_filter_file="/Users/assist/dmz/gen-data/sIR_and_slicing/out/rhino_found_queries_set.txt"

if [ ! -d $output_dir ]
then
    mkdir "$output_dir"
fi


bugs=$(ls $bug_dir)

for b in $bugs
do
    id=$(echo $b | cut -f1 -d ".")

    if [ ! -d $code_dir/$id ]
    then
	continue
    fi    

  #  if [ $id != "RHINO-685403" ]
   # then
#	continue
 #   fi

 #   grep "$id" $slicing_filter_file

  #  if [ "$?" != 0 ]
   # then
#	continue
 #   fi
    
    echo "Working on $id"
    java -jar "$bug_locator_path" -b "$bug_dir/$b" -s "$code_dir/$id" -a 0.2 -o "$output_dir/$id.txt"   
done


echo "Done!"

exit

* Ground truth that are not found with CV:
[ANT]

ANT-30798: <file>org.apache.tools.ant.taskdefs.optional.junit.JUnitTestRunner.java</file>
ANT-32200: <file>org.apache.tools.bzip2.CBZip2InputStream.java</file>
ANT-32973: <file>org.apache.tools.ant.taskdefs.optional.junit.JUnitTestRunner.java</file>
ANT-34374: <file>org.apache.tools.ant.filters.LineContainsRegExp.java</file>
ANT-43969: <file>org.apache.tools.ant.taskdefs.optional.junit.PlainJUnitResultFormatter.java</file>
:<file>org.apache.tools.ant.taskdefs.optional.junit.XMLJUnitResultFormatter.java</file>
:<file>org.apache.tools.ant.taskdefs.optional.junit.BriefJUnitResultFormatter.java</file>
ANT-45284: <file>org.apache.tools.ant.types.resources.selectors.Name.java</file>

ANT-46637: <file>org.apache.tools.zip.ZipFile.java</file>

ANT-46661: <file>org.apache.tools.tar.TarOutputStream.java</file>
:<file>org.apache.tools.bzip2.CBZip2OutputStream.java</file>
:<file>org.apache.tools.tar.TarInputStream.java</file>
:<file>org.apache.tools.zip.ZipFile.java</file>
:<file>org.apache.tools.zip.UnrecognizedExtraField.java</file>

[LUCENE]
LUCENE-588: <file>org.apache.lucene.index.codecs.simpletext.SimpleTextFieldsReader.java</file>
<file>org.apache.lucene.queryParser.standard.nodes.WildcardQueryNode.java</file>

LUCENE-2074: <file>org.apache.lucene.analysis.standard.StandardTokenizerImpl.java</file>

LUCENE-2417: <file>org.apache.lucene.index.DirectoryReader.java</file>
<file>org.apache.lucene.index.SnapshotDeletionPolicy.java</file>

LUCENE-2458: <file>org.apache.lucene.queryParser.precedence.PrecedenceQueryParser.java</file>
<file>org.apache.lucene.queryParser.standard.processors.AnalyzerQueryNodeProcessor.java</file>
<file>org.apache.lucene.queryParser.precedence.PrecedenceQueryParser.java</file>
<file>org.apache.lucene.queryParser.standard.QueryParserWrapper.java</file>
<file>org.apache.lucene.queryParser.MultiFieldQueryParser.java</file>

LUCENE-2462: <file>org.apache.lucene.index.codecs.sep.SepPostingsReaderImpl.java</file>
<file>org.apache.lucene.index.ParallelReader.java</file>
<file>org.apache.lucene.index.FlexTestUtil.java</file>
<file>org.apache.lucene.index.FilterIndexReader.java</file>
<file>org.apache.lucene.index.codecs.preflex.PreFlexFields.java</file>
<file>org.apache.lucene.index.LegacyFieldsEnum.java</file>
<file>org.apache.lucene.index.CheckIndex.java</file>
<file>org.apache.lucene.index.TermPositions.java</file>

LUCENE-2468:<file>org.apache.lucene.search.CachingWrapperFilterHelper.java</file>
<file>org.apache.lucene.index.FilterIndexReader.java</file>

LUCENE-2504: <file>org.apache.lucene.search.JustCompileSearch.java</file>
<file>org.apache.lucene.spatial.tier.DistanceFieldComparatorSource.java</file>

LUCENE-2529: <file>org.apache.lucene.search.vectorhighlight.BaseFragmentsBuilder.java</file>

LUCENE-2741: <file>org.apache.lucene.index.codecs.appending.AppendingTermsDictReader.java</file>
<file>org.apache.lucene.index.codecs.appending.AppendingTermsIndexReader.java</file>
<file>org.apache.lucene.index.codecs.appending.AppendingCodec.java</file>

LUCENE-2759: <file>org.apache.lucene.index.DirectoryReader.java</file>
<file>org.apache.lucene.search.BaseTestRangeFilter.java</file>

LUCENE-2805: <file>org.apache.lucene.index.CheckIndex.java</file>
<file>org.apache.lucene.index.IndexSplitter.java</file>

[RHINO]

RHINO-685403: <file>org.mozilla.javascript.ast.ForLoop.java</file>
<file>org.mozilla.javascript.ast.IfStatement.java</file>
<file>org.mozilla.javascript.ast.ForInLoop.java</file>
<file>org.mozilla.javascript.ast.WhileLoop.java</file>
<file>org.mozilla.javascript.ast.WithStatement.java</file>

RHINO-688023: <file>org.mozilla.javascript.tools.shell.Main.java</file>
<file>org.mozilla.javascript.tools.shell.ShellLine.java</file>
<file>org.mozilla.javascript.tools.shell.Global.java</file>

