#!/bin/sh

projectID="$1"
format="$2"

if [ \( $projectID == "ant53" \) -o \( $projectID == "aspectj" \) -o \( $projectID == "lucene37" \) -o \( $projectID == "rhino" \) ]
then
    echo "[converting bug reports to IR-query format for project] ... [$projectID]"
else
    echo "[error] Incorrect project name"
    exit
fi

     
if [ $format == "r" ]
then
    echo "Using raw format"
    folder_name="queries"
elif [ $format == "s" ]
then
    echo "Using structured format"
    folder_name="structured-queries"    
else
    echo "[error] Incorrect argument, must be either r for raw or s for structured"
    exit
fi



###--------input data----------------------------
REPORTS_DIR="/Users/assist/dmz/ir-dataset/bugs/bug-reports/$projectID"
###-------end required input data----------------

######## Java program setings####################
#JAVA_CLASS="rtp.extractor.QueryExtractor"
QUERY_EXTRACTOR_JAR_PATH="/Users/assist/dmz/lib/ir-jars/query-extractor.jar"

######## OUTPUT FOLDERS #########################
QUERIES_DIR="/Users/assist/dmz/ir-dataset/$folder_name/$projectID"

if [ ! -d "$QUERIES_DIR" ]
then
    mkdir "$QUERIES_DIR"
else
    rm -rfv $QUERIES_DIR/*
fi

REPORTS=$(ls $REPORTS_DIR)

for i in $REPORTS
do
    echo "Working on ... $i"
    INPUT_REPORT_FILE="$REPORTS_DIR/$i"
    OUTPUT_XML_QUERY_FILE="$QUERIES_DIR/$i"
    java -jar $QUERY_EXTRACTOR_JAR_PATH $INPUT_REPORT_FILE $OUTPUT_XML_QUERY_FILE $format
done

