#!/bin/sh

projectID="$1"
query_type="$2"

echo "[converting bug reports to IR-query format for project] ... [$projectID]"

###--------input data----------------------------
REPORTS_DIR="/Users/assist/dmz/ir-dataset/bugs/bug-reports/$projectID"
###-------end required input data----------------

######## Java program setings####################
QUERY_EXTRACTOR_JAR_PATH="/Users/assist/dmz/lib/ir-jars/query-extractor-all.jar"

######## OUTPUT FOLDERS #########################
QUERIES_DIR="/Users/assist/dmz/ir-dataset/queries-$query_type/$projectID"

if [ ! -d "$QUERIES_DIR" ]
then
    mkdir "$QUERIES_DIR"
else
    rm -rfv $QUERIES_DIR/*
fi

REPORTS=$(ls $REPORTS_DIR)

for i in $REPORTS
do
    INPUT_REPORT_FILE="$REPORTS_DIR/$i"
    OUTPUT_XML_QUERY_FILE="$QUERIES_DIR/$i"
    java -jar $QUERY_EXTRACTOR_JAR_PATH $INPUT_REPORT_FILE $OUTPUT_XML_QUERY_FILE $query_type
done

