project="$1" # which project data
pre_post="post-fix" # which version: either faulty or fixed

echo "$#"
if [ $# != 1 ]
then
    echo "[error] please put project name"
    exit
fi


if [ $project == "ant53" ]
then
    echo "tracing $project"
elif [ $project == "lucene37" ]
then
    echo "tracing $project"
elif [ $project ==  "rhino" ]
then
    echo "tracing $project"
else
    echo "[error] incorrect project name"
    exit
fi

base_trace="/Users/assist/dmz/gen-data/jslicer/traces"
base_code="/Users/assist/dmz/ir-dataset/code"
base_failed_test="/Users/assist/dmz/src/rtp/DMZ/failed_tests"

class_dir="$base_code/$project" # directory where test classes and code under test classes are stored
failed_tests="$base_failed_test/$project" # "failed" tests to be traced and sliced

jvslicer_dir="/Users/assist/dmz/tools/javaslicer" # javaslicer folder

traces_output="/Volumes/osxrep/traces/$project/$pre_post" # where to store generated traces >>> move the dir to portable drive due to lack of space

if [ ! -d "$traces_output" ]
then
    mkdir "$traces_output"
else
    #rm -rvf $traces_output/*
    echo "dont remove here"
fi

bugs=$(ls $class_dir) # list of bug IDs

for b in $bugs
do
    if [ $b != "LUCENE-2811" ] 
    then
	continue
    fi

    #if [ $b != "ANT-47593" ]
    #then
#	continue
 #   fi
    

    #traced=$(ls $traces_output | grep ".trace" | cut -f1 -d "." | xargs)

    #echo "$traced" | grep "$b"
        
    #if [ $? == 0 ]
    #then
#	continue	
 #   fi    

    echo "processing $b"        
    
    version=$(ls "$class_dir/$b" | grep "$pre_post") # processing on faulty or fixed version

    if [ ! $? == 0 ]
    then
	echo "[error] something wrong: cant find $pre_post dir"
	continue
    fi
    
    cd "$class_dir/$b/$version" # go to that version's folder where classes are found

    if [ $project == "ant53" ]
    then
	CODE_CLASS="$class_dir/$b/$version/build/classes"
	TEST_CLASS="$class_dir/$b/$version/build/testcases"
	LIB="$class_dir/$b/$version/lib/*"
    elif [ $project == "lucene37" ]
    then
	CODE_CLASS="$class_dir/$b/$version/lucene/build/classes/java"
	TEST_CLASS="$class_dir/$b/$version/lucene/build/classes/test"
	#	 LIB="$class_dir/$b/$version/lib/*"
    elif [ $project == "rhino" ]	 
    then
	CODE_CLASS="$class_dir/$b/$version/build/classes"
	TEST_CLASS="$class_dir/$b/$version/build/test/classes"
	# LIB="$class_dir/$b/$version/lib/*"
    else
	echo "[error] Incorrect $project input"
	exit
    fi

    if [ \( ! -d "$CODE_CLASS" \) -o  \( ! -d "$TEST_CLASS" \) ]
    then
	echo "[error] $project.$b.$version: either code class or test class does not exist"
	exit
    fi

    JUNIT_PATH="/Users/assist/tools/junit/junit.jar:/Users/assist/tools/junit/hamcrest-core-1.3.jar"
    
    CLASSPATH="$JUNIT_PATH:$CODE_CLASS:$TEST_CLASS:$LIB:/Library/Java/JavaVirtualMachines/jdk1.7.0_79.jdk/Contents/Home/jre/lib/tools.jar"
    
    file="$failed_tests/$b.txt" # file that contains test classes to be processed

    tests=$(cat "$file" | cut -f 1 -d ":" | sort | uniq | sed -e 's/\n/ /g' | sed -e "s/\#.*/ /g" | xargs) # get only FQN test classes

    echo "java -cp $CLASSPATH  org.junit.runner.JUnitCore $tests"
    #echo "$tests"

    #exit
    
    java -noverify -debug -Xms4g -Xmx8g -javaagent:$jvslicer_dir/assembly/tracer.jar=tracefile:$traces_output/$b.trace -cp "$CLASSPATH" org.junit.runner.JUnitCore $tests  > $traces_output/$b.log # javaslicer to generate traces for the coressponding test classes
    
    cat "$traces_output/$b.log" | grep "OK " # if all tests are passed
    
    if [ ! $? == 0 ]
    then
	mv $traces_output/$b.log $traces_output/$b.err.log
    fi

done

