#!/usr/bin/ruby
require_relative "main.rb"

project = ARGV[0]
puts project

if ! ((project.eql? "ant53") || (project.eql? "lucene37") || (project.eql? "rhino"))
  puts "[error] incorrect project name. Project names can only be: ant53, lucene37, or rhino"
  exit 
end

faulttracer_data_dir = "/Users/assist/dmz/gen-data/faulttracer"
relative_path  = "post-fix/coverage-data/method-cv"
exact_failed_test_dir = "/Users/assist/dmz/src/rtp/DMZ/failed_tests" + "/" + project

abs_path = faulttracer_data_dir + "/" + project + "/" + relative_path

u_total = 0
i_total = 0
uc_total = 0
ic_total = 0

Dir.entries(abs_path).select{|f| ! f.start_with?(".")}.each do  |file|

  if ! file.eql? "ANT-5270.txt"
    next
  end
  
  puts "[info] processing file: #{file}"

  hash =  Helper.raw_mcv_to_json(abs_path + "/" + file) ### hash ###
 

  ### testing purpose ####
  methods1 = []
  methods2 = []
  hash.each do |test, value|
    value[:traces].each do |method, times|
      methods1 << method.strip.split(":")[0].strip;
      methods2 << method.strip;
    end
  end
  #puts methods1.uniq.size
  #puts methods2.uniq.size
  ########################
  
  ftests = []

  nfile = file.split(".")[0] + ".txt"
  if project.eql? "rhino"
    nfile = "RHINO-" + nfile
  end
  
  File.readlines(exact_failed_test_dir + "/" + nfile).each do |test|
    ftests << test.gsub(/:/,".").strip
  end

  fhash = {} ### fhash: filtered hash ###
  ftests.each do |test|
    fhash.merge!(test => hash[test])
  end

  if ftests.size != fhash.size
    puts "[error] something wrong: the number of extracted tests are expect to be: #{ftests.size}, but instead: #{fhash.size}"
    exit
  end

  ######### class unions and intersections #########
  
  sfhash_class = {} ### sfhash : simplified filtered hash ###
  fhash.each do |test, value|
    classes = []
    if value.nil?
      puts "[error]. something wrong at the following test:"
      puts test
      exit
    end
    value[:traces].each do |method, times|
      m = method.strip.split(":")[0].strip
      ext = File.extname(m)
      c = m[0 .. m.size - 1 - ext.size]
      if c.include?("$")
        puts c
        c = c.split("$")[0]
        puts c
      end
      classes << c
    end
    sfhash_class[test.strip] = classes.uniq
  end

  u_classes = []
  sfhash_class.each do |test, classes|
    u_classes = (u_classes | classes)
  end

  i_classes = u_classes
  sfhash_class.each do |test, classes|
    i_classes = (i_classes & classes)
  end

  puts u_classes.size

  exit

  puts "[info] writing union (intersection) traces with size of #{u_classes.size} (#{i_classes.size}) to #{file} [#{sfhash_class.size} : tests]"
  
  File.open(faulttracer_data_dir + "/" + project + "/post-fix/coverage-data/union/class/" +  file, "w") do |f|
    u_classes.each do |c|
      f.puts c
    end
  end

  File.open(faulttracer_data_dir + "/" + project + "/post-fix/coverage-data/intersection/class/" +  file, "w") do |f|
    i_classes.each do |c|
      f.puts c    
    end
  end

  uc_total += u_classes.size
  ic_total += i_classes.size

  exit


  ######### method unions and intersections #########
  
  sfhash = {} ### sfhash : simplified filtered hash ###
  fhash.each do |test, value|
    methods = []
    if value.nil?
      puts "[error]. something wrong at the following test:"
      puts test
      exit
    end
    value[:traces].each do |method, times|
      methods << method.strip.split(":")[0].strip
    end
    sfhash[test.strip] = methods
  end

  u_methods = []
  sfhash.each do |test, methods|
    u_methods = (u_methods | methods)
  end

  i_methods = u_methods
  sfhash.each do |test, methods|
    i_methods = (i_methods & methods)
  end

  u_total += u_methods.size
  i_total += i_methods.size
  
  puts "[info] writing union (intersection) traces with size of #{u_methods.size} (#{i_methods.size}) to #{file}"
  
  File.open(faulttracer_data_dir + "/" + project + "/post-fix/coverage-data/union/method/" +  file, "w") do |f|
    u_methods.each do |method|
      f.puts method
    end
  end

  File.open(faulttracer_data_dir + "/" + project + "/post-fix/coverage-data/intersection/method/" +  file, "w") do |f|
    i_methods.each do |method|
      f.puts method    
    end
  end  
  
end

puts "Union: #{uc_total}"
puts "Intersection: #{ic_total}"


puts "Union: #{u_total}"
puts "Intersection: #{i_total}"

######### end of methods union and intersection parts #########



