project="ant" # which project data set to run junit [ant, lucene, aspectj, rhino]
pre_post="faulty" # which version: either fixed or faulty [fixed, faulty]

junit_log="/Users/assist/ndataset/dlo/projects/junit-log/$project/$pre_post" # dir of logs of junit running
class_dir="/Users/assist/ndataset/dlo/projects/$project" # dir of classes
failed_tests="/Users/assist/dataset/TCM/DLo/amldata/failed_tests/$project" # test classes to run
ruby_dir="/Users/assist/irscripts"


bugs=$(ls $class_dir) # list of bug IDs

for b in $bugs
do
    
    echo "processing $b"
    
    version=$(ls "$class_dir/$b" | grep "$pre_post")

    if [ ! $? == 0 ]
    then
	continue
    fi
    
    cd "$class_dir/$b/$version"
    
    CODE_CLASS="$class_dir/$b/$version/build/classes"
    TEST_CLASS="$class_dir/$b/$version/build/testcases"
    LIB="$class_dir/$b/$version/build/lib/*.jar"
    CLASSPATH="/Users/assist/tools/junit/junit.jar:/Users/assist/tools/junit/hamcrest-core-1.3.jar:$CODE_CLASS:$TEST_CLASS:$LIB:/Library/Java/JavaVirtualMachines/jdk1.7.0_79.jdk/Contents/Home/jre/lib/tools.jar"

    file="$failed_tests/$b.txt"
    tests=$(cat "$file" | cut -f 1 -d ":" | sort | uniq | sed -e 's/\n/ /g' | xargs) # get only FQN test classes
    
    echo "Junit test runing of the following classes: \n $tests \n" > "$junit_log/$b.txt" 
    echo "Wilord967!" | sudo -S java -Xms512m -Xmx4g -cp $CLASSPATH org.junit.runner.JUnitCore $tests >> "$junit_log/$b.txt"

done

